/**
 * Monster Egg
 *
 * @author Chan <gml1580@naver.com>
 * 이 스크립트는 달걀을 몹을 향해 던지면, 몹이 달걀이 되어 버립니다
 * 뜯는 것을 허용하나 무단수정은 금지입니다
 */

var mobArray = [];
var dataArray = [];

const MOB = [10, 11, 12, 13, 14, 15, 32, 33, 34, 35, 36, 37, 38, 39];
const SPAWN_EGG = 383;
const EGG = 82;


function entityRemovedHook( ent )	{
	if( Entity.getEntityTypeId( ent ) == EGG )	{
		for( var i in mobArray )	{
			if( parseInt( Entity.getX( ent ) ) - 0.5 <= parseInt( Entity.getX( mobArray[i] ) ) && parseInt( Entity.getY( ent ) ) - 0.5 <= parseInt( Entity.getY( mobArray[i] ) ) && parseInt( Entity.getZ( ent ) ) - 0.5 <= parseInt( Entity.getZ( mobArray[i] ) ) && parseInt( Entity.getX( ent ) ) + 0.5 >= parseInt( Entity.getX( mobArray[i] ) ) && parseInt( Entity.getY( ent ) ) + 0.5 >= parseInt( Entity.getY( mobArray[i] ) ) && parseInt( Entity.getZ( ent ) ) + 0.5 >= parseInt( Entity.getZ( mobArray[i] ) ) )	{
				Entity.remove( mobArray[i] );
				Entity.remove( ent );
				Level.dropItem( Entity.getX( ent ), Entity.getY( ent ), Entity.getZ( ent ), 0, SPAWN_EGG, 1, dataArray[i] );
			}
		}
	}
	for( var i in mobArray )	{ 
		if( ent == mobArray[i] )	{
			mobArray.splice( i, 1 );
			dataArray.splice( i, 1 );
		}
	} 
}

function entityAddedHook( ent )	{
	for( var i in MOB )	{
		if( Entity.getEntityTypeId( ent ) == MOB[i] )	{
			mobArray.push( ent );
			dataArray.push( Entity.getEntityTypeId( ent ) );
			}
		}
}